<?php
namespace cool_team\HW3_Underwriters\src\configs;
use cool_team\HW3_Underwriters\src\configs\Config as C;
require_once '../../autoloader.php';

function connect_db(){
  $mysqli = new \mysqli(
    C::HOSTNAME,
    C::USER_NAME, 
    C::PASSWORD
  );
  if ($mysqli->connect_error) {
    echo 'Errno: '.$mysqli->connect_errno;
    exit();
  }
  echo 'Success: A proper connection to MySQL was made.';
  return $mysqli;  
}

function create_db($mysqli){
  $queries = array(
    "DROP DATABASE IF EXISTS PolicyDB",
    "CREATE DATABASE IF NOT EXISTS PolicyDB",
    "USE PolicyDB",
  );
  exec_queries( $mysqli,$queries);
}

function create_tables($mysqli){
  //Create 2 tables- PolicyType and Policy. Policy table has a foreign key constraint which is the id from PolicyType table
  $table_queries = array(
    "CREATE TABLE PolicyType(
      policy_type_id INT(6) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
      policy_type_name VARCHAR(255) NOT NULL
    )",

    "CREATE TABLE Policy(
      policy_id INT(6) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
      policy_name VARCHAR(255) NOT NULL,
      agent_email VARCHAR(255) NOT NULL,
      duration INT(6) NOT NULL,
      policy_description TEXT NOT NULL,
      popularity INT(6) UNSIGNED NOT NULL,
      type_id INT(6) UNSIGNED NOT NULL,
      create_time DATETIME NOT NULL,
      FOREIGN KEY (type_id) REFERENCES PolicyType(policy_type_id)
    )"
  );
  exec_queries( $mysqli,$table_queries);
  }

  
  function close_connection($mysqli){
    $mysqli->close();
  }

  function exec_queries( $mysqli,$queries){
    foreach($queries as $q){
      if($mysqli->query($q) == TRUE){
        echo "Query execution successful!\n";
      }
      else{
        echo "Error executing query: ". $mysqli->error. "\n";
      }
    }
  }

  function init_insert($mysqli){
    $insert_data = array(
      "INSERT INTO PolicyType(policy_type_name) VALUES(\"Lair\")",
      
      "INSERT INTO Policy(policy_name, agent_email, duration, policy_description, popularity,create_time, type_id) 
      VALUES(\"Coffin Relocation\", \"john.doe@gmail.com\",10, \"Coffin Reloc Policy Info\", 1, CURRENT_TIMESTAMP(), 1)"

    );
    exec_queries( $mysqli, $insert_data);
  }
  
  $mysqli = connect_db();
  create_db($mysqli);
  create_tables($mysqli);
  init_insert($mysqli);
  close_connection($mysqli);