<?php
namespace cool_team\HW3_Underwriters\src\models;

class AddNewPolicyModel extends BaseModel{
    private $title;
    private $email;
    private $duration;
    private $description;
    private $policy_type;
    function __construct($title,$email,$duration,$description,$policy_type)
    {
        $this->title = $title;
        $this->email = $email;
        $this->duration = $duration;
        $this->description = $description;
        $this->policy_type = $policy_type;
        parent::__construct();
    }

    function sanitize_inputs(){
        $this->title = htmlspecialchars($this->title); //FILTER_SANITIZE_STRING is deprecated in php 8
        $this->email = filter_var($this->email,FILTER_SANITIZE_EMAIL);
        $this->duration = intval(filter_var($this->duration,FILTER_SANITIZE_NUMBER_INT));
        $this->description = htmlspecialchars($this->description);
        $this->policy_type = htmlspecialchars($this->policy_type);
        if(empty($this->title) ||empty($this->email) ||empty($this->duration) ||empty($this->description) )
            return false;
        else 
            return true;
    }
    function insert_policy(){
        
        $policy_type_query = "SELECT policy_type_id FROM PolicyDB.PolicyType
        WHERE policy_type_name=\"$this->policy_type\"";
        
        $results = mysqli_query($this->db, $policy_type_query);
        $policy_type_id = mysqli_fetch_array($results)["policy_type_id"];
        
        $insert_policy = "INSERT INTO PolicyDB.Policy(policy_name, agent_email, duration, policy_description, popularity,create_time, type_id) 
        VALUES(\"$this->title\", \"$this->email\" ,$this->duration, 
        \"$this->description\", 1, CURRENT_TIMESTAMP(), $policy_type_id)" ;
        $results = mysqli_query($this->db, $insert_policy);
        parent::close_connection();
    }
}
